<?php
namespace Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class NecessidadeComprasController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = 'necessidadeCompras';
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
    
    public function saveUni(DTO\Request $request, DTO\Response $response )
    {
		$data = $request->getDataSet()->getRows();
		
        $a=0;
    		    
	    $query = 'SELECT * FROM FILINECE WHERE CDFILIAL = :CDFILINECCMP';
	    $stmt = $this->con->prepare($query);
		$stmt->execute(array(
		    "CDFILINECCMP" => $data[0]['CDFILINECCMP']
		));
		
		$a = $stmt->fetchAll();
		
	    if (sizeof($a)==0) {
	        $query = 'SELECT * FROM FILINECE WHERE CDFILIAL = :CDFILIAL AND CDFILINECCMP = :CDFILINECCMP';
		    $stmt = $this->con->prepare($query);
			$stmt->execute(array(
			    "CDFILIAL" => $data[0]['CDFILIAL'],
			    "CDFILINECCMP" => $data[0]['CDFILINECCMP']
			));
			
			$a = $stmt->fetchAll();
			
			if (sizeof($a)==0) {
    		    $query = 'INSERT INTO FILINECE (CDFILIAL, CDFILINECCMP, IDSOLIPREV) VALUES (:CDFILIAL, :CDFILINECCMP, :IDSOLIPREV)';
    			$stmt = $this->con->prepare($query);
    			$stmt->execute(array(
    			    "CDFILIAL" => $data[0]['CDFILIAL'],
    			    "CDFILINECCMP" => $data[0]['CDFILINECCMP'],
    			    "IDSOLIPREV" => $data[0]['IDSOLIPREV']
    			));
			} else {
			    $query = 'UPDATE FILINECE SET IDSOLIPREV = :IDSOLIPREV WHERE CDFILINECCMP = :CDFILINECCMP AND CDFILIAL = :CDFILIAL';
    			$stmt = $this->con->prepare($query);
    			$stmt->execute(array(
    			    "CDFILIAL" => $data[0]['CDFILIAL'],
    			    "CDFILINECCMP" => $data[0]['CDFILINECCMP'],
    			    "IDSOLIPREV" => $data[0]['IDSOLIPREV']
    			));
			}
	    } else {
	        $response->setError(new Error("Unidade para necessidade de compras está cadastrada como unidade.", 500));
	    }
    }
}