<?php
namespace Fiscal\Repositories;

/**
 *
 */
class IntgNotafiscal extends \Doctrine\ORM\EntityRepository
{

    /**
     * @param $nrorg
     * @param $cdForneced
     * @param $cdSerie
     * @param $nrNotaFisc
     * @return mixed|null
     */
    public function retornaChaveAcessoDocumento($nrorg, $cdForneced, $cdSerie, $nrNotaFisc) {
        $dql = "SELECT inf
            FROM \Fiscal\Entities\IntgNotafiscal inf
            WHERE inf.nrorg      = :nrorg
            AND inf.cdforneced   = :cdforneced
            AND inf.cdserieentr  = :cdserieentr
            AND inf.nrnotafisc   = :nrnotafisc
            AND (inf.idimportada = :idimportada OR inf.idimportada IS NULL)";

        $params = array (
            "nrorg"         => $nrorg,
            "cdforneced"     => $cdForneced,
            "cdserieentr"   => $cdSerie,
            "nrnotafisc"    => $nrNotaFisc,
            "idimportada"   => 'N'
        );


        $return = $this->getEntityManager()->createQuery($dql)->execute($params);

        //@todo estudar o uso de "return current($return);" lembrando que o current em um array vazio retorna "false"
        return count($return) ? current($return) : null;
    }

    public function updateIntg_notafiscal($params){
                        $sql = "UPDATE INTG_NOTAFISCAL
                                   SET IDIMPORTADA = 'S',
                                       IDSTATUSNFE  = 'U',
                                       CDFILIRECE = ?,
                                       DTUTILIZAXML = SYSDATE,
                                       CDFILIAL  =  ?,
                                       NRLANCTONF = ?
                                 WHERE NRACESSONFE = ?";
                        $connection = $this->getEntityManager()->getConnection();
                        return $connection->executeUpdate($sql,$params);
                    }

    public function updateIntg_notafiscalDelete($params) {
                        $sql = "UPDATE INTG_NOTAFISCAL
                                   SET IDIMPORTADA = null,
                                       IDSTATUSNFE  = 'N',
                                       CDFILIRECE = null,
                                       DTUTILIZAXML = null,
                                       CDFILIAL  =  null,
                                       NRLANCTONF = null
                                 WHERE NRACESSONFE = ?";
                        $connection = $this->getEntityManager()->getConnection();
                        return $connection->executeUpdate($sql,$params);
                    }

}