CREATE OR REPLACE TRIGGER USR_ATU_ITEMPRODUTO_NGD
BEFORE DELETE OR INSERT OR UPDATE OF QTITEMPROD,
                                     VRUNITITEM
ON ITEMPRODUTO  FOR EACH ROW
DECLARE
  V_IDPESQITEM  VARCHAR2(300);
  V_ERRO        VARCHAR2(300);
  V_CHAVE_NF    VARCHAR2(2000);
  V_CDFILIAL    NOTAFISCAL.CDFILIAL%TYPE;
  V_NRLANCTONF  NOTAFISCAL.NRLANCTONF%TYPE;
  V_CDARVPROD   PRODUTO.CDARVPROD%TYPE;
  V_CDFILIEMIT  NOTAFISCAL.CDFILIEMIT%TYPE;
  V_CDFILIRECE  NOTAFISCAL.CDFILIRECE%TYPE;
  V_DTENTRSAID  USR_ITEMPRODUTO_NGD.DTENTRSAID%TYPE;
BEGIN
   IF DELETING THEN
      SELECT NVL(MAX(CDARVPROD), '')
        INTO V_CDARVPROD
        FROM PRODUTO
       WHERE CDPRODUTO = :NEW.CDPRODUTO;
      SELECT MAX(CDFILIEMIT), MAX(CDFILIRECE), MAX(TO_CHAR(DTENTRSAID, 'YYYYMMDD'))
        INTO V_CDFILIEMIT, V_CDFILIRECE, V_DTENTRSAID
        FROM NOTAFISCAL
       WHERE NOTAFISCAL.CDFILIAL   = :NEW.CDFILIAL
         AND NOTAFISCAL.NRLANCTONF = :NEW.NRLANCTONF;
      IF V_CDARVPROD <> '' THEN
         SELECT MAX(CHAVE_NF), MAX(CDARVPROD||'-'||CDFILIEMIT||'-'||CDFILIRECE||'-'||DTENTRSAID)
           INTO V_CHAVE_NF, V_IDPESQITEM
           FROM USR_ITEMPRODUTO_NGD
          WHERE INSTR(USR_ITEMPRODUTO_NGD.CHAVE_NF, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL)||NVL(:NEW.NRLANCTONF, :OLD.NRLANCTONF)) > 0
            AND USR_ITEMPRODUTO_NGD.CDARVPROD = V_CDARVPROD;
         BEGIN
            UPDATE USR_ITEMPRODUTO_NGD
               SET TPINTERFACE        = 'E',
                   DTINTERFACEORI     = SYSDATE,
                   DTINTERFACEDEST    = NULL,
                   STATUS             = '1'
             WHERE INSTR(USR_ITEMPRODUTO_NGD.CHAVE_NF, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL)||NVL(:NEW.NRLANCTONF, :OLD.NRLANCTONF)) > 0
               AND USR_ITEMPRODUTO_NGD.CDARVPROD  = V_CDARVPROD;

              WHILE LENGTH(V_CHAVE_NF) >= 11 LOOP
                  V_CDFILIAL   := SUBSTR(V_CHAVE_NF, 1, 4);
                  V_NRLANCTONF := SUBSTR(V_CHAVE_NF, 5, 10);
                  V_CHAVE_NF   := SUBSTR(V_CHAVE_NF, 16, LENGTH(V_CHAVE_NF));
                  UPDATE ITEMPRODUTO
                     SET USR_NGD_INTEGRADO = 'N'
                   WHERE CDFILIAL   = V_CDFILIAL
                     AND NRLANCTONF = V_NRLANCTONF
                     AND CDFILIAL   <> NVL(:NEW.CDFILIAL, :OLD.CDFILIAL)
                     AND NRLANCTONF <> NVL(:NEW.NRLANCTONF, :OLD.NRLANCTONF)
                     AND ITEMPRODUTO.CDPRODUTO = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)
                     AND NVL(USR_NGD_INTEGRADO, 'N') =  'S';
              END LOOP;
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '0',
                   OBSSTATUS  = NULL
             WHERE IDPROCESSO = 'USR_ITEMPRODUTO_NGD'
               AND IDPESQITEM = V_IDPESQITEM;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '0', NULL, V_IDPESQITEM);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_ERRO       := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '1',
                      OBSSTATUS  = V_ERRO
                WHERE IDPROCESSO = 'USR_ITEMPRODUTO_NGD'
                  AND IDPESQITEM = V_IDPESQITEM;
               IF SQL%NOTFOUND THEN
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
               END IF;
            END;
         END;
      END IF;
   ELSE
     :NEW.USR_NGD_INTEGRADO := 'N';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_ITEMPRODUTO_NGD','6.37.015'); END;
/
