/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_INTEFORN                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao do Interlocutor do Fornecedor            */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_INTEFORN' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
  DROP TRIGGER DTULTATU_INTEFORN
  GO

CREATE TRIGGER DTULTATU_INTEFORN
ON INTEFORN
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'INTEFORN', 'CDFORNECED=' + CDFORNECED +
                                  ';CDINTERLOC=' + CDINTERLOC +
                                  ';IDTIPOINTER='+ IDTIPOINTER+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE INTEFORN
      SET DTULTATUINFO = GETDATE()
      FROM INSERTED
      WHERE
        ISNULL(INTEFORN.CDFORNECED,0)  = ISNULL(INSERTED.CDFORNECED ,0) AND
        ISNULL(INTEFORN.CDINTERLOC,0)  = ISNULL(INSERTED.CDINTERLOC ,0) AND
        ISNULL(INTEFORN.IDTIPOINTER,0) = ISNULL(INSERTED.IDTIPOINTER,0);
   END;
END;
GO

