# -*- coding: utf-8 -*-
import xml.etree.ElementTree as ET
import sys
import sqlReader
import re

version = sys.version_info[0]
idCode = 1
paransReport = []

def getReportName():
    reportName = []
    if version <= 2:
        reportName.append(raw_input("Qual será o nome do relatório: "))
    else:
        reportName.append(input("Qual será o nome do relatório: "))
    reportName.append(".rptdesign")
    reportName = ''.join(reportName)
    return reportName
    
def getReportTitle():
    if version <= 2:
        reportTitle = raw_input("Qual será o título do relatório: ").decode("utf-8")
    else:
        reportTitle = input("Qual será o título do relatório: ")
    return reportTitle
    
def setReportTitle(reportTitle, root):
    textProperty = root.find('page-setup/simple-master-page/page-header/text/text-property')
    textProperty.text = ' ' + reportTitle + ' '
    
def getNewId():
    global idCode
    idCode += 1
    return str(idCode)
        
def createDataSet(root, queryName, query):
    dataSets = root.find('data-sets')
    if dataSets == None:
        dataSets = ET.SubElement(root, 'data-sets')
    odaDataSet = ET.SubElement(dataSets, 'oda-data-set', name = queryName, extensionID = 'org.eclipse.birt.report.data.oda.jdbc.JdbcSelectDataSet', id = getNewId())
    createListParams(root, query, odaDataSet)
    ET.SubElement(odaDataSet, 'structure', name = 'cachedMetaData')
    ET.SubElement(odaDataSet, 'property', name = 'dataSource').text = 'Data Source'
    ET.SubElement(odaDataSet, 'xml-property', name = 'queryText').text = ' ' + query + ' '
    
def createListParams(root, query, odaDataSet):
    params = sqlReader.getSqlParams(query)
    listProperty = ET.SubElement(odaDataSet, 'list-property', name = 'parameters')
    
    for i in range(len(params)):
        structure = ET.SubElement(listProperty, 'structure')
        ET.SubElement(structure, 'property', name = 'name').text = params[i]
        ET.SubElement(structure, 'property', name = 'dataType').text = 'string'
        ET.SubElement(structure, 'property', name = 'position').text = str(i)
        
        
        paramName = False
        if params[i][1] == '_':
            paramName = createParamReport(root, params[i])
        
        if paramName:
            ET.SubElement(structure, 'expression', name = 'paramName').text = paramName
        else:
            ET.SubElement(structure, 'expression', name = 'defaultValue', type = 'javascript').text = '8080'
            
        ET.SubElement(structure, 'property', name = 'isInput').text = 'true'
        ET.SubElement(structure, 'property', name = 'isOutput').text = 'false'

def createParamReport(root, param):
    paramReportName = re.split("[0-9]", param)[0]
    global paransReport
    
    if paransReport.count(paramReportName) != 0:
        return False
    paransReport.append(paramReportName)
    parameters = root.find('parameters')
    if parameters == None:
        parameters = ET.SubElement(root, 'parameters')
    
    scalarParameter = ET.SubElement(parameters, 'scalar-parameter', name = paramReportName, id = getNewId())
    ET.SubElement(scalarParameter, 'property', name = 'valueType').text = 'static'
    ET.SubElement(scalarParameter, 'property', name = 'isRequired').text = 'false'
    ET.SubElement(scalarParameter, 'property', name = 'dataType').text = 'string'
    ET.SubElement(scalarParameter, 'property', name = 'distinct').text = 'true'
    ET.SubElement(scalarParameter, 'property', name = 'isInput').text = 'true'
    ET.SubElement(scalarParameter, 'property', name = 'isInput').text = 'true'
    simplePropertyList = ET.SubElement(scalarParameter, 'simple-property-list', name = 'defaultValue')
    ET.SubElement(simplePropertyList, 'value', type = 'constant')
    ET.SubElement(scalarParameter, 'list-property', name = 'selectionList')
    ET.SubElement(scalarParameter, 'property', name = 'paramType').text = 'simple'
    ET.SubElement(scalarParameter, 'property', name = 'controlType').text = 'text-box'
    structure = ET.SubElement(scalarParameter, 'structure', name = 'format')
    ET.SubElement(structure, 'property', name = 'category').text = 'Unformatted'
    
    return paramReportName